#!/bin/bash

MYSQL=$(which mysql);
mysql_table='' #库名称
mysql_user='root' #mysql用户
user_registration_number_display_range='60' #用户注册数显示范围（天）
user_recharge_number_display_range='60' #用户充值数显示范围（天）
user_purchases_display_range='60' #用户购买数显示范围（天）
site_dir='/home/wwwroot/sspanel'
registered_cache_file="${site_dir}/resources/views/material/admin/chart/registrationTrend.data" #注册数据缓存文件
recharge_cache_file="${site_dir}/resources/views/material/admin/chart/dailyRechargeAmount.data" #充值数据缓存文件
rurchase_data_cache_file="${site_dir}/resources/views/material/admin/chart/userPurchasesDisplayRange.data" #充值数据缓存文件
user_stock_cache_file="${site_dir}/resources/views/material/admin/chart/userStock.data" #用户存量数据缓存文件
station_time='2020-02' #建站时间。格式：年-月。例如：2020-02
#不知道的去phpmyadmin看sspanel库user表reg_date的升序结果

query(){
$MYSQL $mysql_table -u $mysql_user << EOF
$sql
EOF
}

#获取每日注册用户数据
get_daily_registered_users(){
	start=$(date +%s)
	for (( i=1; i <= ${user_registration_number_display_range}; i++ ))
	do
		today=$(date -d "$(expr $i - 1) day ago" +"%Y-%m-%d")
		one_days_ago=$(date -d "$i day ago" +"%Y-%m-%d")
		one_days_ago_2=$(date -d "$i day ago" +"%m-%d")
		sql="SELECT id FROM \`user\` WHERE \`reg_date\` BETWEEN '$one_days_ago 00:00:00' AND '$today 00:00:00'"
		how_many_people=$(query | wc -l) #数据有多少行（减一后）就是有多少人注册
		#有人注册的情况下才减去1，不然会出现注册人数为负的情况
		if [[ ${how_many_people} != '0' ]];then
			how_many_people=$(expr $how_many_people - 1) #第一行是字段名不是注册用户数据所以要减去
		fi
		if [[ $i = '1' ]];then
			echo "[\"$one_days_ago_2\", $how_many_people]," > "${registered_cache_file}"
		else
			sed "1i [\"$one_days_ago_2\", $how_many_people]," -i "${registered_cache_file}"
		fi
		echo "(${i}/${user_registration_number_display_range}) 正在查询日期：${one_days_ago} ..."
	done
	stop=$(date +%s)
	echo "合计：生成数据花费了 $(expr $stop - $start)s"
}

#获取每日充值金额数据
get_daily_recharge_amount(){
	start=$(date +%s)
	for (( i=1; i <= ${user_recharge_number_display_range}; i++ ))
	do
		today=$(date -d "$(expr $i - 1) day ago" +"%Y-%m-%d")
		one_days_ago=$(date -d "$i day ago" +"%Y-%m-%d")
		one_days_ago_2=$(date -d "$i day ago" +"%m-%d")
		#先查数据
		sql="SELECT number FROM \`code\` WHERE \`usedatetime\` BETWEEN '$one_days_ago 00:00:00' AND '$today 00:00:00'"
		query > /root/.money.data
		#删掉第一行的字段名
		sed -i '1d' /root/.money.data
		#金额相加
		money=$(sed ":a;N;s/\n/ + /g;ta" /root/.money.data | bc)
		#输出
		if [[ $i = '1' ]];then
			echo "[\"$one_days_ago_2\", $money]," > "${recharge_cache_file}"
		else
			sed "1i [\"$one_days_ago_2\", $money]," -i "${recharge_cache_file}"
		fi
		echo "(${i}/${user_recharge_number_display_range}) 正在查询日期：${one_days_ago} ..."
	done
	stop=$(date +%s)
	echo "合计：生成数据花费了 $(expr $stop - $start)s"
}

#获取每日购买数据
get_daily_purchase_data(){
	start=$(date +%s)
	for (( i=1; i <= ${user_purchases_display_range}; i++ ))
	do
		today=$(date -d "$(expr $i - 1) day ago" +"%Y-%m-%d")
		today=$(date -d "$today 00:00:00" +%s)
		one_days_ago=$(date -d "$i day ago" +"%Y-%m-%d")
		one_days_ago=$(date -d "$one_days_ago 00:00:00" +%s)
		one_days_ago_2=$(date -d "$i day ago" +"%m-%d")
		sql="SELECT id FROM \`bought\` WHERE \`datetime\` BETWEEN '$one_days_ago' AND '$today'"
		how_many_purchase_records=$(query | wc -l) #数据有多少行（减一后）就是有多少条购买结论
		#有人购买的情况下才减去1，不然会出现购买人数为负的情况
		if [[ ${how_many_purchase_records} != '0' ]];then
			how_many_purchase_records=$(expr $how_many_purchase_records - 1) #第一行是字段名不是注册用户数据所以要减去
		fi
		if [[ $i = '1' ]];then
			echo "[\"$one_days_ago_2\", $how_many_purchase_records]," > "${rurchase_data_cache_file}"
		else
			sed "1i [\"$one_days_ago_2\", $how_many_purchase_records]," -i "${rurchase_data_cache_file}"
		fi
		echo "(${i}/${user_purchases_display_range}) 正在查询日期：$(date -d "$i day ago" +"%Y-%m-%d") ..."
	done
	stop=$(date +%s)
	echo "合计：生成数据花费了 $(expr $stop - $start)s"
}

#用户总注册趋势
user_stock(){
	start=$(date +%s)
	now_time=$(date "+%Y-%m") #当前时间
	echo "(0) 正在查询月份：${now_time} ..."
	sql="SELECT id FROM \`user\` WHERE \`reg_date\` < '$(date "+%Y-%m-%d %H:%M:%S")'"
	how_many_people=$(expr $(query | wc -l) - 1)
	echo "[\"$now_time\", $how_many_people]," > "${user_stock_cache_file}"
	for (( i=1; i <= 1000; i++ ))
	do
		current_month=$(date -d "$(date +%Y%m)01 $i month ago" +%Y-%m) #当前月份
		sql="SELECT id FROM \`user\` WHERE \`reg_date\` < '${current_month}-01 00:00:00'"
		if [[ "$(query | wc -l)" != '0' ]];then
			how_many_people=$(expr $(query | wc -l) - 1)
		fi
		#输出
		sed "1i [\"$current_month\", $how_many_people]," -i "${user_stock_cache_file}"
		#退出
		echo "($i) 正在查询月份：${current_month} ..."
		if [[ "${current_month}" = "${station_time}" ]];then
			break
		fi
	done
	echo "合计：生成数据花费了 $(expr $(date +%s) - $start) s"
}

clear
case "${1}" in
	user)
		get_daily_registered_users;;
	money)
		get_daily_recharge_amount;;
	buy)
		get_daily_purchase_data;;
	registered|reg)
		user_stock;;
	all)
		all_start=$(date +%s)
		get_daily_registered_users
		get_daily_recharge_amount
		get_daily_purchase_data
		user_stock
		all_stop=$(date +%s)
		echo "合计：生成数据总共花费了 $(expr $all_stop - $all_start)s";;
esac

#END 2020-02-20